#ifndef __ImageEffects__dispatch_parallel__
#define __ImageEffects__dispatch_parallel__

#include <stdio.h>

#ifdef __APPLE__
#ifndef EFFECTS_USE_GCD
#define EFFECTS_USE_GCD 1
#endif
#endif // iOS

#ifdef __ANDROID__
#ifndef EFFECTS_USE_CPP11_THREADS
#define EFFECTS_USE_CPP11_THREADS 1
#endif
#endif // Android

#ifdef __cplusplus
extern "C" {
#endif

/**
 * Function for parallel dispatching.
 */
typedef void (*dispatch_work_func)(void *, size_t);

/**
 * Dispatch function in multiple threads using available framework if any.
 */
void dispatch_parallel(dispatch_work_func work_func, int num_iters, void* context);

#ifdef __cplusplus
}
#endif

#endif /* defined(__ImageEffects__dispatch_parallel__) */
